using System;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using DataBinding.Domain;
using DataBinding.ServiceLayer;

public partial class BindingInCodeBehind : Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        this.customersGridView.RowDataBound += BindGridRow;
        if (! IsPostBack)
        {
            BindCustomersGrid();
        }
    }

    private void BindCustomersGrid()
    {
        this.customersGridView.DataSource = new CustomerTask().GetAllCustomers();
        this.customersGridView.DataBind();
    }


    private void BindGridRow(object sender,GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            Customer customer = (Customer) e.Row.DataItem;
            GetControlFromRowAs<HtmlGenericControl>(e.Row, "companyNameSpan").InnerText = customer.CompanyName;
            GetControlFromRowAs<HtmlGenericControl>(e.Row, "contactNameSpan").InnerText = customer.ContactName;
            GetControlFromRowAs<HtmlGenericControl>(e.Row, "contactTitleSpan").InnerText = customer.ContactTitle;
            GetControlFromRowAs<HtmlGenericControl>(e.Row, "addressSpan").InnerText = customer.Address;
            GetControlFromRowAs<HtmlGenericControl>(e.Row, "citySpan").InnerText = customer.City;
            GetControlFromRowAs<HtmlGenericControl>(e.Row, "regionSpan").InnerText = customer.Region;
            GetControlFromRowAs<HtmlGenericControl>(e.Row, "postalCodeSpan").InnerText = customer.PostalCode;
            GetControlFromRowAs<HtmlGenericControl>(e.Row, "countrySpan").InnerText = customer.Country;
            GetControlFromRowAs<HtmlGenericControl>(e.Row, "phoneSpan").InnerText = customer.Phone;
            GetControlFromRowAs<HtmlGenericControl>(e.Row, "faxSpan").InnerText = customer.Fax;
        }
    }
    
    private ControlType GetControlFromRowAs<ControlType>(GridViewRow row,string controlName) where ControlType : Control
    {
        return (ControlType) row.FindControl(controlName);
    }
}