using System.Collections.Generic;
using System.Transactions;
using DataBinding.DataAccess.Mappers;
using DataBinding.Domain;
using NUnit.Framework;

namespace DataBinding.DataAccess.Test
{
    [TestFixture]
    public class CustomerMapperTest
    {
        [Test]
        public void ShouldBeAbleToGetAllCustomers()
        {
            using (new TransactionScope())
            {
                TestDatabaseGateway gateway = new TestDatabaseGateway();
                int existingCustomerRows = gateway.GetRowCountFor("Customers");

                string sql = "INSERT INTO Customers VALUES('BOODH','Boodhoos Beverages','Jean-Paul Boodhoo','Sales Representative','Fauntleroy Circus','Canada',NULL,'EC2 5NT','UK','(171) 555-1212',NULL)";
                gateway.ExecuteStatement(sql);

                IList<Customer> customers = new CustomerMapper().GetAllCustomers();
                Assert.AreEqual(existingCustomerRows + 1, customers.Count);                
            }
        }

    }
}