using System;
using System.Data;
using NUnit.Framework;

namespace DataBinding.DataAccess.Test
{
    [TestFixture]
    public class DatabaseConnectionTest
    {
        [Test]
        public void DatabaseConnectionShouldBeOpenAfterCreation()
        {
            using (DatabaseConnection connection = new DatabaseConnection())
            {
                Assert.AreEqual(ConnectionState.Open,connection.UnderlyingConnection.State);
            }
        }

        [Test]
        public void UnderlyingConnectionShouldBeNullAfterDispose()
        {
            DatabaseConnection connection = null;
            using (connection = new DatabaseConnection())
            {
                
            }
            Assert.IsNull(connection.UnderlyingConnection);
        }

        [Test]
        public void UnderlyingConnectionShouldClose()
        {
            using (DatabaseConnection connection = new DatabaseConnection())
            {                
                connection.Close();
                Assert.AreEqual(ConnectionState.Closed,connection.UnderlyingConnection.State);
            }
        }
    }
}